<script lang="ts">
  import Column from 'components/Column';
  import Card from 'components/Card';
  import {
    columnIssues,
    dragStore,
    updateDragStore,
  } from 'stores/kanbanStore';
  import { COLUMNS } from 'constants/columns';
  import { mutation } from '@urql/svelte';
  import {
    UpdateIssueDocument,
    type UpdateIssueMutation,
    type UpdateIssueMutationVariables,
  } from 'generated/graphql';
  import {
    kanbanId,
    userId,
  } from 'stores/authStore';
  import { onDestroy } from 'svelte';
  
  const updateIssueMutation = mutation<UpdateIssueMutation, UpdateIssueMutationVariables>({ query: UpdateIssueDocument });

  const updateIssue = () => updateIssueMutation({
    issueId: $dragStore.issueId,
    authorId: $userId,
    kanbanId: $kanbanId,
    data: {
      column: $dragStore.destinationColumn,
    },
  });

  const handleMouseUp = async () => {
    if (!$dragStore.isDragging) return;
    if (!$dragStore.destinationColumn) {
      updateDragStore({ isDragging: false });
      return;
    }
    await updateIssue();
    updateDragStore({ isDragging: false });
};
  
  window.addEventListener('mouseup', handleMouseUp);
  
  onDestroy(() => window.removeEventListener('mouseup', handleMouseUp));
</script>

<div class="w-full grid grid-cols-3 gap-4 pt-8">
  {#each COLUMNS as { id: column, name }}
    <Column {column} {name} issueCount={$columnIssues[column]?.length}>
      {#each $columnIssues[column] as issue}
        <Card {...issue} />
      {/each}
    </Column>
  {/each}
</div>